.TH BURST %manext1% 2013-02-08 "%nmhversion%"
.
.\" %nmhwarning%
.
.SH NAME
burst \- explode digests into nmh messages
.SH SYNOPSIS
.HP 5
.na
.B burst
.RB [ \-help ]
.RB [ \-version ]
.RI [ +folder ]
.RI [ msgs ]
.RB [ \-inplace " | " \-noinplace ]
.RB [ \-mime " | " \-nomime ]
.RB [ \-automime ]
.RB [ \-quiet " | " \-noquiet ]
.RB [ \-verbose " | " \-noverbose ]
.ad
.SH DESCRIPTION
.B burst
considers the specified messages in the named folder to be
Internet digests, and explodes them in that folder.
.PP
If
.B \-inplace
is given, each digest is replaced by its \*(lqtable
of contents\*(rq and the digest is removed.
.B burst
then renumbers the messages which follow the digest, in the folder,
making room for each of the exploded messages, which are placed
immediately after the \*(lqtable of contents\*(rq.
.PP
If
.B \-noinplace
is given, each digest is preserved, no table of contents
is produced, and the exploded messages are placed at the end of the
folder.  Other messages in the folder are not affected.
.PP
If
.B \-automime
is given,
.B burst
will try to determine if the message is formatted with MIME and contains MIME parts of
type \*(lqmessage/rfc822\*(rq.  If it does, it will burst the message using MIME
formatting rules.  The
.B \-mime
switch can be used to enforce the use of MIME formatting.  The
.B \-nomime
switch will force
.B burst
to use RFC 934 rules.
.PP
The
.B \-quiet
switch directs
.B burst
to be silent about reporting
messages that are not in digest format.
.PP
The
.B \-verbose
switch directs
.B burst
to tell the user the general
actions that it is taking to explode the digest.
.PP
It turns out that
.B burst
works equally well on forwarded messages
and blind-carbon-copies as on Internet digests, provided
that the former were generated by
.B forw
or
.BR send .
.SH FILES
.TP 20
$HOME/.mh_profile
The user's profile.
.SH "PROFILE COMPONENTS"
.PD 0
.TP 20
Path:
To determine the user's nmh directory.
.TP
Current\-Folder:
To find the default current folder.
.TP
Msg\-Protect:
To set mode when creating a new message.
.PD
.SH "SEE ALSO"
.IR inc (1),
.IR pack (1)
.PP
.I
Proposed Standard for Message Encapsulation
(RFC 934)
.SH DEFAULTS
.PD 0
.TP 20
+folder
The current folder.
.TP
msgs
The current message.
.TP
\-noinplace
.TP
\-automime
.TP
\-noquiet
.TP
\-noverbose
.PD
.SH CONTEXT
If a folder is given, it will become the current folder.  If
.B \-inplace
is given, then the first message burst becomes the current message.
This leaves the context ready for a
.B show
of the table of contents
of the digest, and a
.B next
to see the first message of the digest.  If
.B \-noinplace
is given, then the first message extracted from the
first digest burst becomes the current message.  This leaves the context
in a similar, but not identical, state to the context achieved when using
.BR \-inplace .
.SH BUGS
The
.B burst
program enforces a limit of approximately 1,000 on the number of
messages which may be
.B burst
from a single message. There is usually no limit on the number of
messages which may reside in the folder after the
.BR burst ing.
.PP
Although
.B burst
uses a sophisticated algorithm to determine where
one encapsulated message ends and another begins, not all digestifying
programs use an encapsulation algorithm.  In degenerate cases, this
usually results in
.B burst
finding an encapsulation boundary
prematurely and splitting a single encapsulated message into two or
more messages.  These erroneous digestifying programs should be fixed.
.PP
Furthermore, any text which appears after the last encapsulated message
is not placed in a separate message by
.BR burst .
In the case of
digestified messages, this text is usually an \*(lqEnd of digest\*(rq
string.  As a result of this possibly unfriendly behavior on the
part of
.BR burst ,
note that when the
.B \-inplace
option is used,
this trailing information is lost.  In practice, this is not a problem
since correspondents usually place remarks in text prior to the first
encapsulated message, and this information is not lost.
